﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using C1.Win.C1FlexGrid;

namespace AddingChartInC1FlexGrid
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        C1.Win.C1Chart.C1Chart chart;
        string data;
        bool ischart = false;
        Point chartPoint;
        Form f;

        #region Reposition Chart
        void chart_MouseDown(object sender, MouseEventArgs e)
        {
            chartPoint = e.Location;          // Capture the Chart Control for moving
        }

        void chart_MouseCaptureChanged(object sender, EventArgs e)
        {
            Point tmpPoint = c1FlexGrid1.HitTest().Point;
            // drop it in the user specified place in the grid
            chart.Location = new Point(tmpPoint.X - chartPoint.X, tmpPoint.Y - chartPoint.Y); 
        }
        #endregion 

        private void Form1_Load(object sender, EventArgs e)
        {
            c1FlexGrid1.AllowFiltering = true;
        }

        #region Remove Chart
        private void removeChartToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (ischart == true)
            {
                c1FlexGrid1.Controls.Clear();      // Clear the chart from the grid
                ischart = false;
            }
        }
        #endregion

        #region Add Chart
        private void addChartToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (c1FlexGrid1.Clip != "")
            {
                data = c1FlexGrid1.Clip;                      // capture the selected data in the grid
                string[] values = data.Split('\r');
                if (ischart == true)                           // if the chart already exists in the grid then clear the series collection  
                {
                    chart.ChartGroups[0].ChartData.SeriesList.Clear();
                    C1.Win.C1Chart.ChartDataSeries cds;        // Add new data
                    for (int i = 0; i < values.Length; i++)
                    {
                        if (values[i] != "")
                        {
                            cds = new C1.Win.C1Chart.ChartDataSeries();
                            cds = chart.ChartGroups[0].ChartData.SeriesList.AddNewSeries();
                            cds.PointData.Length = 1;
                            cds.Label = "Series " + values[i].ToString();
                            cds.Y[0] = Convert.ToInt16(values[i]);
                        }
                    }
                }
                else                                        // if it doesn't, then add a new chart
                {
                    chart = new C1.Win.C1Chart.C1Chart();
                    c1FlexGrid1.Controls.Add(chart);
                    chart.Location = new Point(200, 100);
                    chart.Size = new Size(300,300);
                    chart.Legend.Visible = true;
                    chart.Header.Visible = true;
                    chart.Header.Text = "ADDED CHART CONTROL";
                    chart.MouseDown += new MouseEventHandler(chart_MouseDown);
                    chart.MouseCaptureChanged += new EventHandler(chart_MouseCaptureChanged);
                    chart.ChartGroups[0].ChartType = C1.Win.C1Chart.Chart2DTypeEnum.Pie;
                    chart.ChartGroups[0].ChartData.SeriesList.Clear();
                    C1.Win.C1Chart.ChartDataSeries cds;
                    for (int i = 0; i < values.Length; i++)       // Add Data
                    {
                        if (values[i] != "")
                        {
                            cds = new C1.Win.C1Chart.ChartDataSeries();
                            cds = chart.ChartGroups[0].ChartData.SeriesList.AddNewSeries();
                            cds.PointData.Length = 1;
                            cds.Label = "Series " + values[i].ToString();
                            cds.Y[0] = Convert.ToInt16(values[i]);
                        }
                    }
                }
                ischart = true;                                // now the chart is there on the grid
            }
        }
        #endregion

        private void c1FlexGrid1_MouseClick(object sender, MouseEventArgs e)
        {
            if (c1FlexGrid1.HitTest().Type == HitTestTypeEnum.FilterIcon)
            {
                foreach (Form ff in Application.OpenForms)
                {
                    if (ff.Name == "FilterEditorForm")
                    {
                        f = ff;
                        ToolStripButton applybtn = ((ToolStripButton)((System.Windows.Forms.ToolStrip)(f.Controls[0])).Items[2]);
                        applybtn.Click += new EventHandler(applybtn_Click);
                        ToolStripButton clearbtn = ((ToolStripButton)((System.Windows.Forms.ToolStrip)(f.Controls[0])).Items[1]);
                        clearbtn.Click += new EventHandler(clearbtn_Click);
                    }
                }
            }
        }

        #region Clear button
        void clearbtn_Click(object sender, EventArgs e)
        {
            if (c1FlexGrid1.Clip != "")                    // if data has been selected in the grid then set default  
            {                                               // data in  the chart upon clearing
                data = c1FlexGrid1.Clip;
                string[] values = data.Split('\r');
                if (ischart == true)
                {
                    chart.ChartGroups[0].ChartData.SeriesList.Clear();
                    C1.Win.C1Chart.ChartDataSeries cds;
                    for (int i = 0; i < values.Length; i++)
                    {
                        if (values[i] != "")
                        {
                            cds = new C1.Win.C1Chart.ChartDataSeries();
                            cds = chart.ChartGroups[0].ChartData.SeriesList.AddNewSeries();
                            cds.PointData.Length = 1;
                            cds.Label = "Series " + values[i].ToString();
                            cds.Y[0] = Convert.ToInt16(values[i]);
                        }
                    }
                }
            }
            else
            {
                c1FlexGrid1.Controls.Clear();             // if data hasn't been selected in the grid then 
                ischart = false;                          // upon clearing the chart will be removed
            }
        }
        #endregion

        #region Apply button
        void applybtn_Click(object sender, EventArgs e)
        {
            if (c1FlexGrid1.Clip != "")       //check if the data is selected or not 
            {
                if (chart != null)            // check if the chart exists or not
                {
                    foreach (Column col in c1FlexGrid1.Cols)
                    {
                        if (col.Filter.IsActive == true)         // check which column has the active filter
                        {
                            if (((C1.Win.C1FlexGrid.ColumnFilter)(this.c1FlexGrid1.Cols[col.SafeIndex].Filter)).ValueFilter.ShowValues != null)
                            {
                                object[] values = ((C1.Win.C1FlexGrid.ColumnFilter)(this.c1FlexGrid1.Cols[col.Index].Filter)).ValueFilter.ShowValues;
                                chart.ChartGroups[0].ChartData.SeriesList.Clear();
                                C1.Win.C1Chart.ChartDataSeries cds;
                                for (int i = 0; i < values.Length; i++)
                                {
                                    if (values[i].ToString() != "")
                                    {                              // Add the filtered data in the Chart
                                        cds = new C1.Win.C1Chart.ChartDataSeries();
                                        cds = chart.ChartGroups[0].ChartData.SeriesList.AddNewSeries();
                                        cds.PointData.Length = 1;
                                        cds.Label = "Series " + values[i].ToString();
                                        cds.Y[0] = Convert.ToInt16(values[i]);
                                    }
                                }
                            }
                        }
                    }

                }
            }
            else                                // if the data is not selected then remove the chart from the grid
            {                                   // upon applying filtering
                c1FlexGrid1.Controls.Clear();
                ischart = false;
            }
        }
        #endregion
    }
}
